
#ifndef __GUIGTK_H__
#define __GUIGTK_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include "ShishenSho.h"

G_BEGIN_DECLS


#define TYPE_GUI_GTK (gui_gtk_get_type ())
#define GUI_GTK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GUI_GTK, GuiGtk))
#define GUI_GTK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GUI_GTK, GuiGtkClass))
#define IS_GUI_GTK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GUI_GTK))
#define IS_GUI_GTK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GUI_GTK))
#define GUI_GTK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GUI_GTK, GuiGtkClass))

typedef struct _GuiGtk GuiGtk;
typedef struct _GuiGtkClass GuiGtkClass;
typedef struct _GuiGtkPrivate GuiGtkPrivate;

struct _GuiGtk {
	GObject parent_instance;
	GuiGtkPrivate * priv;
	gint cstate;
	gint pstate;
};

struct _GuiGtkClass {
	GObjectClass parent_class;
};


void gui_gtk_on_wingame_destroy (GtkWidget* widget);
void gui_gtk_on_new_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_hint_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_undo_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_small_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_medium_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_large_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_hard_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_easy_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_classic_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_letters_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_gravity_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_time_counter_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_about_activate (GtkWidget* widget, GuiGtk* self);
void gui_gtk_on_aboutok_clicked (GtkWidget* widget, GuiGtk* self);
gboolean gui_gtk_on_key_press (GtkWidget* widget, GdkEventKey* key, GuiGtk* self);
gboolean gui_gtk_on_update_time (GuiGtk* self);
void gui_gtk_connect_signals (const char* handler_name, GObject* object, const char* signal_name, const char* signal_data, GObject* connect_object, gboolean after, GuiGtk* self);
void gui_gtk_on_draw_expose_event (GtkWidget* widget, GdkEventExpose* event, GuiGtk* self);
void gui_gtk_on_draw_button_press_event (GtkWidget* widget, GdkEventButton* event, GuiGtk* self);
void gui_gtk_draw_message (GuiGtk* self, gint x, gint y, gboolean centered, const char* message, const char* color, const char* font);
void gui_gtk_gui_init (int* args_length1, char*** args);
void gui_gtk_gui_main (void);
GuiGtk* gui_gtk_new (void);
ShishenSho* gui_gtk_get_app (GuiGtk* self);
void gui_gtk_set_app (GuiGtk* self, ShishenSho* value);
GType gui_gtk_get_type (void);


G_END_DECLS

#endif
